#
# This is an example scene for RayLab 1.0
#
# Author:  Marcus Geelnard
# Date:    28-Nov-95
#


Globals:
    picwidth  640
    picheight 480
    recdepth  5
    backgroundcolor 0 0.2 0.6    ; We want a clear blue sky
:end



**
**  The first object of the scene is a checkered plane
**

PLANE:
    normal  0 0 1
    offset  0
    texture:                     ; The surface of the plane is well-
        pattern  checker         ;  polished and has blue checkers.
        colormap 2
            0.0  0 0 0.2
            1.0  0.8 0.9 1.0
        diffuse  0.7
        ambient  0.3
        phong    0.6
        reflect  0.45 0.49 0.6
        transform:
            scale 0.4 0.4 0.4
        :end
    :end
:end



**
**  The next part of the scene will feature a table
**


Deftexture:                      ; Next we will declare a default texture
    pattern rings                ;  that looks like dark wood, which will
    colormap 5                   ;  be used for the table.
        0.0  0.6 0.4 0.0
        0.4  0.5 0.3 0.0
        0.5  0.3 0.1 0.0
        0.6  0.5 0.2 0.0
        1.0  0.6 0.4 0.0
    diffuse 0.8
    ambient 0.2
    phong   0.4
    phongsize 20
    reflect 0 0 0
    transform:
        scale   0.04 0.04 0.04
        rotate  50 0 10
    :end
:end


BOX:
    corners  -0.6 -1.0 0.8       ; Here is the top of the table.
              0.6  1.0 0.86
:end


BOX:
    corners  -0.03 -0.03 0.0     ; ...and here come the legs.
              0.03  0.03 0.8
    transform:
        move  -0.52 -0.92 0.0
    :end
:end

BOX:
    corners  -0.03 -0.03 0.0
              0.03  0.03 0.8
    transform:
        move  0.52 -0.92 0.0
    :end
:end

BOX:
    corners  -0.03 -0.03 0.0
              0.03  0.03 0.8
    transform:
        move  -0.52 0.92 0.0
    :end
:end

BOX:
    corners  -0.03 -0.03 0.0
              0.03  0.03 0.8
    transform:
        move  0.52  0.92 0.0
    :end
:end


Deftexture:
    default                     ; Reset the default texture
:end



**
**  Somebody has left a ball on the floor
**

SPHERE:
    centre 0 0 0
    radius 0.2
    texture:
        colormap 2
            0.0  0 1 0
            1.0  1 0 0
        pattern checker
        phong  0.7
        phongsize 40
        reflect 0.3 0.3 0.3
        diffuse 0.6
        ambient 0.4
        transform:
            rotate 40 20 0
            move -0.3 -1.2 0.2
        :end
    :end
    transform:
        move -0.3 -1.2 0.2
    :end
:end



**
**  And then we have the light-sources and the camera
**

LIGHT:
    location -3 -2 2            ; A white light-source is added
    color     1 1 1
:end


CAMERA:
    location  2 -3 1.4          ; And a camera is placed to
    viewpoint 0 -0.4 0.5        ; look the table (use default aspect)
:end
